"use strict";
/**
 * LazyInfiniteScroll - Plugin for infinite scroll
 * requires IntersectionObserver (or polyfill)
 *
 * Author: Bogdan Barbu
 * Team: Codingheads (codingheads.com)
 */

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classPrivateFieldGet(receiver, privateMap) { var descriptor = _classExtractFieldDescriptor(receiver, privateMap, "get"); return _classApplyDescriptorGet(receiver, descriptor); }

function _classApplyDescriptorGet(receiver, descriptor) { if (descriptor.get) { return descriptor.get.call(receiver); } return descriptor.value; }

function _classPrivateMethodGet(receiver, privateSet, fn) { if (!privateSet.has(receiver)) { throw new TypeError("attempted to get private field on non-instance"); } return fn; }

function _classPrivateFieldSet(receiver, privateMap, value) { var descriptor = _classExtractFieldDescriptor(receiver, privateMap, "set"); _classApplyDescriptorSet(receiver, descriptor, value); return value; }

function _classExtractFieldDescriptor(receiver, privateMap, action) { if (!privateMap.has(receiver)) { throw new TypeError("attempted to " + action + " private field on non-instance"); } return privateMap.get(receiver); }

function _classApplyDescriptorSet(receiver, descriptor, value) { if (descriptor.set) { descriptor.set.call(receiver, value); } else { if (!descriptor.writable) { throw new TypeError("attempted to set read only private field"); } descriptor.value = value; } }

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _container = /*#__PURE__*/new WeakMap();

var _pagination = /*#__PURE__*/new WeakMap();

var _element = /*#__PURE__*/new WeakMap();

var _currentLocation = /*#__PURE__*/new WeakMap();

var _observer = /*#__PURE__*/new WeakMap();

var _loadInlineOptions = /*#__PURE__*/new WeakSet();

var _getNextPageURL = /*#__PURE__*/new WeakSet();

var _parsePage = /*#__PURE__*/new WeakSet();

var _triggerEvent = /*#__PURE__*/new WeakSet();

var _initLoadOnScroll = /*#__PURE__*/new WeakSet();

var LazyInfiniteScroll = /*#__PURE__*/function () {
  function LazyInfiniteScroll() {
    var _this = this;

    var element = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : document.body;

    var _ref = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {},
        _ref$containerSelecto = _ref.containerSelector,
        containerSelector = _ref$containerSelecto === void 0 ? '.articles-wrapper' : _ref$containerSelecto,
        _ref$itemSelector = _ref.itemSelector,
        itemSelector = _ref$itemSelector === void 0 ? 'article' : _ref$itemSelector,
        _ref$paginationContai = _ref.paginationContainerSelector,
        paginationContainerSelector = _ref$paginationContai === void 0 ? '.page-pagination' : _ref$paginationContai,
        _ref$paginationLinksS = _ref.paginationLinksSelector,
        paginationLinksSelector = _ref$paginationLinksS === void 0 ? '.page-pagination a' : _ref$paginationLinksS,
        _ref$loadButton = _ref.loadButton,
        loadButton = _ref$loadButton === void 0 ? false : _ref$loadButton,
        _ref$loadOnScroll = _ref.loadOnScroll,
        loadOnScroll = _ref$loadOnScroll === void 0 ? false : _ref$loadOnScroll,
        _ref$numberOfPages = _ref.numberOfPages,
        numberOfPages = _ref$numberOfPages === void 0 ? false : _ref$numberOfPages,
        _ref$currentPageNumbe = _ref.currentPageNumber,
        currentPageNumber = _ref$currentPageNumbe === void 0 ? 1 : _ref$currentPageNumbe,
        _ref$syncSelectors = _ref.syncSelectors,
        syncSelectors = _ref$syncSelectors === void 0 ? [] : _ref$syncSelectors,
        _ref$updateUrl = _ref.updateUrl,
        updateUrl = _ref$updateUrl === void 0 ? true : _ref$updateUrl;

    var init = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : true;

    _classCallCheck(this, LazyInfiniteScroll);

    _initLoadOnScroll.add(this);

    _triggerEvent.add(this);

    _parsePage.add(this);

    _getNextPageURL.add(this);

    _loadInlineOptions.add(this);

    _defineProperty(this, "containerSelector", '.articles-wrapper');

    _container.set(this, {
      writable: true,
      value: null
    });

    _defineProperty(this, "itemSelector", 'article');

    _defineProperty(this, "paginationContainerSelector", '.page-pagination');

    _defineProperty(this, "paginationLinksSelector", '.page-pagination a');

    _pagination.set(this, {
      writable: true,
      value: null
    });

    _defineProperty(this, "loadButton", false);

    _defineProperty(this, "loadOnScroll", false);

    _defineProperty(this, "numberOfPages", false);

    _defineProperty(this, "currentPageNumber", 1);

    _defineProperty(this, "syncSelectors", []);

    _defineProperty(this, "updateUrl", true);

    _element.set(this, {
      writable: true,
      value: null
    });

    _currentLocation.set(this, {
      writable: true,
      value: window.location.href
    });

    _observer.set(this, {
      writable: true,
      value: null
    });

    _defineProperty(this, "init", function () {
      _classPrivateFieldSet(_this, _container, document.querySelector(_this.containerSelector));

      if (!_classPrivateFieldGet(_this, _container)) {
        throw new Error("Lazyload container not found for selector: ".concat(_this.containerSelector));
      }

      _classPrivateFieldSet(_this, _pagination, document.querySelector(_this.paginationContainerSelector));

      _classPrivateFieldSet(_this, _currentLocation, _classPrivateFieldGet(_this, _element).dataset.currentLocation || window.location.href); // load more on click (load more or pagination)


      document.addEventListener('click', function (e) {
        var target = e.target;

        if (target) {
          if (typeof _this.loadButton == 'string' && target.matches(_this.loadButton) || target == _this.loadButton) {
            e.preventDefault();

            _this.loadNextPage();
          } else if (target.matches(_this.paginationLinksSelector)) {
            var newURL = target.href || target.value;

            if (newURL) {
              e.preventDefault();

              if (_classPrivateMethodGet(_this, _triggerEvent, _triggerEvent2).call(_this, 'infiniteScrollLoadingFullPage', {
                nextUrl: newURL,
                triggerElement: target
              }, target)) {
                _this.loadPage(newURL, true);
              }
            }
          }
        }
      }); // handle "data-load-full-page" anchors

      var fullPageLoad = function fullPageLoad(e) {
        var target = e.target;

        if (target && (e.type == 'click' && target.matches('[data-load-full-page]') || e.type == 'change' && target.matches('[data-load-full-page-select]'))) {
          var newURL = target.dataset.loadFullPage || target.href || target.value;

          if (newURL) {
            e.preventDefault();

            if (_classPrivateMethodGet(_this, _triggerEvent, _triggerEvent2).call(_this, 'infiniteScrollLoadingFullPage', {
              nextUrl: newURL,
              triggerElement: target
            }, target)) {
              _this.loadPage(newURL, true);
            }
          }
        }
      };

      _classPrivateFieldGet(_this, _element).addEventListener('click', fullPageLoad);

      _classPrivateFieldGet(_this, _element).addEventListener('change', fullPageLoad); // observe intersection


      _classPrivateMethodGet(_this, _initLoadOnScroll, _initLoadOnScroll2).call(_this);

      _classPrivateMethodGet(_this, _triggerEvent, _triggerEvent2).call(_this, 'infiniteScrollInit');
    });

    _classPrivateFieldSet(this, _element, element); // use the inline options, if available


    var _settings = {
      containerSelector: containerSelector,
      itemSelector: itemSelector,
      paginationContainerSelector: paginationContainerSelector,
      paginationLinksSelector: paginationLinksSelector,
      loadButton: loadButton,
      loadOnScroll: loadOnScroll,
      numberOfPages: numberOfPages,
      currentPageNumber: currentPageNumber,
      syncSelectors: syncSelectors,
      updateUrl: updateUrl
    };

    _classPrivateMethodGet(this, _loadInlineOptions, _loadInlineOptions2).call(this, _settings); // initialize the plugin


    _classPrivateFieldGet(this, _element).LazyInfiniteScroll = this;
    if (init) this.init();
  } // use the inline options, if available


  _createClass(LazyInfiniteScroll, [{
    key: "loadPage",
    value: // load a page by URL
    function loadPage(nextUrl) {
      var _this2 = this;

      var resetContent = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;

      _classPrivateFieldGet(this, _element).classList.add('loading');

      if (resetContent) {
        _classPrivateFieldGet(this, _element).classList.add('loading-new');
      }

      var parseData = function parseData(data) {
        _classPrivateMethodGet(_this2, _parsePage, _parsePage2).call(_this2, data, nextUrl, resetContent);

        _classPrivateMethodGet(_this2, _triggerEvent, _triggerEvent2).call(_this2, 'infiniteScrollLoadedPage');

        _classPrivateMethodGet(_this2, _triggerEvent, _triggerEvent2).call(_this2, 'post-load'); // for scripts that depend on this event

      };

      fetch(nextUrl, {
        credentials: 'include'
      }).then(function (response) {
        // handle redirected URLs
        if (response.redirected) {
          nextUrl = response.url;
        }

        return response;
      }).then(function (response) {
        return response.text();
      }).then(parseData)["catch"](function (error) {
        console.error(error);
        console.log('There has been an error loading the next page.', error.toString());
      });
    } // load the next page

  }, {
    key: "loadNextPage",
    value: function loadNextPage() {
      var resetContent = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;

      if (!_classPrivateFieldGet(this, _element).classList.contains('loading')) {
        var nextUrl = _classPrivateMethodGet(this, _getNextPageURL, _getNextPageURL2).call(this, document.documentElement);

        if (nextUrl) {
          if (_classPrivateMethodGet(this, _triggerEvent, _triggerEvent2).call(this, 'infiniteScrollLoadingPage', {
            nextUrl: nextUrl,
            resetContent: resetContent
          })) {
            this.loadPage(nextUrl, resetContent);
          }
        }
      }
    }
  }]);

  return LazyInfiniteScroll;
}();

function _loadInlineOptions2() {
  var _this3 = this;

  var settings = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  var inlineOptions = 'options' in _classPrivateFieldGet(this, _element).dataset ? JSON.parse(_classPrivateFieldGet(this, _element).dataset.options) : [];
  settings = _objectSpread(_objectSpread({}, settings), inlineOptions);
  Object.keys(settings).forEach(function (key) {
    _this3[key] = settings[key];
  });
}

function _getNextPageURL2(content) {
  var _this4 = this;

  var nextPageURL = false;
  var pages = typeof this.paginationLinksSelector == 'string' ? content.querySelectorAll(this.paginationLinksSelector) : this.paginationLinksSelector;

  if (pages.length) {
    nextPageURL = [].reduce.call(pages, function (url, page) {
      if (!url) {
        if (page.href != _classPrivateFieldGet(_this4, _currentLocation) && page.getAttribute('href') != _classPrivateFieldGet(_this4, _currentLocation)) {
          url = page.href;
        }
      }

      return url;
    }, false);
  }

  return nextPageURL;
}

function _parsePage2(data) {
  var _this5 = this;

  var nextUrl = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;
  var resetContent = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;
  // add the new items
  var newHtml = document.createElement('html');
  newHtml.innerHTML = data;
  var newItems = newHtml.querySelectorAll("".concat(this.containerSelector, " ").concat(this.itemSelector));
  var fragment = document.createDocumentFragment();
  if (newItems.length) newItems.forEach(function (item) {
    return fragment.appendChild(item);
  });

  if (resetContent) {
    _classPrivateFieldGet(this, _container).innerHTML = '';
  }

  _classPrivateFieldGet(this, _container).appendChild(fragment); // allow hooking into the new items


  _classPrivateMethodGet(this, _triggerEvent, _triggerEvent2).call(this, 'infiniteScrollNewItems', {
    newItems: newItems,
    resetContent: resetContent
  }); // trigger foundation if there is foundation in the page


  if ('jQuery' in window && 'foundation' in window.jQuery.fn) {
    window.jQuery(newItems).foundation();
  } // replace the pagination


  if (_classPrivateFieldGet(this, _pagination)) {
    var paginationContent = newHtml.querySelector(this.paginationContainerSelector);

    if (paginationContent) {
      _classPrivateFieldGet(this, _pagination).innerHTML = paginationContent.innerHTML;

      _classPrivateMethodGet(this, _initLoadOnScroll, _initLoadOnScroll2).call(this);
    } else {
      _classPrivateFieldGet(this, _pagination).innerHTML = '';
    }
  } // replace the other sync selectors


  if (this.syncSelectors && this.syncSelectors.length) {
    this.syncSelectors.forEach(function (selector) {
      var newElement = newHtml.querySelector(selector),
          oldElement = _classPrivateFieldGet(_this5, _element).querySelector(selector);

      if (newElement && oldElement) {
        oldElement.innerHTML = newElement.innerHTML;
      }
    });
  }

  if (resetContent) {
    _classPrivateMethodGet(this, _triggerEvent, _triggerEvent2).call(this, 'infiniteScrollFullPageContent', {
      newHtml: newHtml,
      newItems: newItems
    });
  } // remove the "loading" class


  _classPrivateFieldGet(this, _element).classList.remove('loading');

  _classPrivateFieldGet(this, _element).classList.remove('loading-new');

  if (!resetContent) {
    this.currentPageNumber++;

    if (this.numberOfPages && this.currentPageNumber > this.numberOfPages) {
      _classPrivateFieldGet(this, _pagination).remove();
    }
  } else {
    this.currentPageNumber = 1;

    _classPrivateMethodGet(this, _loadInlineOptions, _loadInlineOptions2).call(this);

    if (nextUrl && this.updateUrl) history.pushState(null, null, nextUrl);
  }
}

function _triggerEvent2(eventType) {
  var detail = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  var target = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : null;
  var event = new CustomEvent(eventType, {
    bubbles: true,
    cancelable: true,
    detail: _objectSpread({
      infiniteScroll: this
    }, detail)
  });
  return !target ? _classPrivateFieldGet(this, _element).dispatchEvent(event) : target.dispatchEvent(event);
}

function _initLoadOnScroll2() {
  var _this6 = this;

  _classPrivateFieldSet(this, _pagination, document.querySelector(this.paginationContainerSelector)); // observe intersection


  if (this.loadOnScroll && _classPrivateFieldGet(this, _pagination)) {
    if (!_classPrivateFieldGet(this, _observer)) {
      _classPrivateFieldSet(this, _observer, new IntersectionObserver(function () {
        return _this6.loadNextPage();
      }, {
        rootMargin: '200px'
      }));
    }

    _classPrivateFieldGet(this, _observer).observe(_classPrivateFieldGet(this, _pagination));
  }
}

exports["default"] = LazyInfiniteScroll; // register as a jQuery plugin, if jQuery is available

if ('jQuery' in window) {
  (function ($) {
    $.fn.lazyInfiniteScroll = function () {
      var settings = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
      this.each(function () {
        if (!this.LazyInfiniteScroll) {
          // don't initialize twice
          new LazyInfiniteScroll(this, settings);
        }
      });
      return this;
    };
  })(window.jQuery);
}