function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classPrivateFieldGet(receiver, privateMap) { var descriptor = _classExtractFieldDescriptor(receiver, privateMap, "get"); return _classApplyDescriptorGet(receiver, descriptor); }

function _classApplyDescriptorGet(receiver, descriptor) { if (descriptor.get) { return descriptor.get.call(receiver); } return descriptor.value; }

function _classPrivateMethodGet(receiver, privateSet, fn) { if (!privateSet.has(receiver)) { throw new TypeError("attempted to get private field on non-instance"); } return fn; }

function _classPrivateFieldSet(receiver, privateMap, value) { var descriptor = _classExtractFieldDescriptor(receiver, privateMap, "set"); _classApplyDescriptorSet(receiver, descriptor, value); return value; }

function _classExtractFieldDescriptor(receiver, privateMap, action) { if (!privateMap.has(receiver)) { throw new TypeError("attempted to " + action + " private field on non-instance"); } return privateMap.get(receiver); }

function _classApplyDescriptorSet(receiver, descriptor, value) { if (descriptor.set) { descriptor.set.call(receiver, value); } else { if (!descriptor.writable) { throw new TypeError("attempted to set read only private field"); } descriptor.value = value; } }

var _container = /*#__PURE__*/new WeakMap();

var _pagination = /*#__PURE__*/new WeakMap();

var _element = /*#__PURE__*/new WeakMap();

var _currentLocation = /*#__PURE__*/new WeakMap();

var _observer = /*#__PURE__*/new WeakMap();

var _loadInlineOptions = /*#__PURE__*/new WeakSet();

var _getNextPageURL = /*#__PURE__*/new WeakSet();

var _parsePage = /*#__PURE__*/new WeakSet();

var _triggerEvent = /*#__PURE__*/new WeakSet();

var _initLoadOnScroll = /*#__PURE__*/new WeakSet();

/**
 * LazyInfiniteScroll - Plugin for infinite scroll
 * requires IntersectionObserver (or polyfill)
 *
 * Author: Bogdan Barbu
 * Team: Codingheads (codingheads.com)
 */
export default class LazyInfiniteScroll {
  constructor(element = document.body, {
    containerSelector = '.articles-wrapper',
    itemSelector = 'article',
    paginationContainerSelector = '.page-pagination',
    paginationLinksSelector = '.page-pagination a',
    loadButton = false,
    loadOnScroll = false,
    numberOfPages = false,
    currentPageNumber = 1,
    syncSelectors = [],
    updateUrl = true
  } = {}, init = true) {
    _initLoadOnScroll.add(this);

    _triggerEvent.add(this);

    _parsePage.add(this);

    _getNextPageURL.add(this);

    _loadInlineOptions.add(this);

    _defineProperty(this, "containerSelector", '.articles-wrapper');

    _container.set(this, {
      writable: true,
      value: null
    });

    _defineProperty(this, "itemSelector", 'article');

    _defineProperty(this, "paginationContainerSelector", '.page-pagination');

    _defineProperty(this, "paginationLinksSelector", '.page-pagination a');

    _pagination.set(this, {
      writable: true,
      value: null
    });

    _defineProperty(this, "loadButton", false);

    _defineProperty(this, "loadOnScroll", false);

    _defineProperty(this, "numberOfPages", false);

    _defineProperty(this, "currentPageNumber", 1);

    _defineProperty(this, "syncSelectors", []);

    _defineProperty(this, "updateUrl", true);

    _element.set(this, {
      writable: true,
      value: null
    });

    _currentLocation.set(this, {
      writable: true,
      value: window.location.href
    });

    _observer.set(this, {
      writable: true,
      value: null
    });

    _defineProperty(this, "init", () => {
      _classPrivateFieldSet(this, _container, document.querySelector(this.containerSelector));

      if (!_classPrivateFieldGet(this, _container)) {
        throw new Error(`Lazyload container not found for selector: ${this.containerSelector}`);
      }

      _classPrivateFieldSet(this, _pagination, document.querySelector(this.paginationContainerSelector));

      _classPrivateFieldSet(this, _currentLocation, _classPrivateFieldGet(this, _element).dataset.currentLocation || window.location.href); // load more on click (load more or pagination)


      document.addEventListener('click', e => {
        const target = e.target;

        if (target) {
          if (typeof this.loadButton == 'string' && target.matches(this.loadButton) || target == this.loadButton) {
            e.preventDefault();
            this.loadNextPage();
          } else if (target.matches(this.paginationLinksSelector)) {
            const newURL = target.href || target.value;

            if (newURL) {
              e.preventDefault();

              if (_classPrivateMethodGet(this, _triggerEvent, _triggerEvent2).call(this, 'infiniteScrollLoadingFullPage', {
                nextUrl: newURL,
                triggerElement: target
              }, target)) {
                this.loadPage(newURL, true);
              }
            }
          }
        }
      }); // handle "data-load-full-page" anchors

      const fullPageLoad = e => {
        const target = e.target;

        if (target && (e.type == 'click' && target.matches('[data-load-full-page]') || e.type == 'change' && target.matches('[data-load-full-page-select]'))) {
          const newURL = target.dataset.loadFullPage || target.href || target.value;

          if (newURL) {
            e.preventDefault();

            if (_classPrivateMethodGet(this, _triggerEvent, _triggerEvent2).call(this, 'infiniteScrollLoadingFullPage', {
              nextUrl: newURL,
              triggerElement: target
            }, target)) {
              this.loadPage(newURL, true);
            }
          }
        }
      };

      _classPrivateFieldGet(this, _element).addEventListener('click', fullPageLoad);

      _classPrivateFieldGet(this, _element).addEventListener('change', fullPageLoad); // observe intersection


      _classPrivateMethodGet(this, _initLoadOnScroll, _initLoadOnScroll2).call(this);

      _classPrivateMethodGet(this, _triggerEvent, _triggerEvent2).call(this, 'infiniteScrollInit');
    });

    _classPrivateFieldSet(this, _element, element); // use the inline options, if available


    const _settings = {
      containerSelector,
      itemSelector,
      paginationContainerSelector,
      paginationLinksSelector,
      loadButton,
      loadOnScroll,
      numberOfPages,
      currentPageNumber,
      syncSelectors,
      updateUrl
    };

    _classPrivateMethodGet(this, _loadInlineOptions, _loadInlineOptions2).call(this, _settings); // initialize the plugin


    _classPrivateFieldGet(this, _element).LazyInfiniteScroll = this;
    if (init) this.init();
  } // use the inline options, if available


  // load a page by URL
  loadPage(nextUrl, resetContent = false) {
    _classPrivateFieldGet(this, _element).classList.add('loading');

    if (resetContent) {
      _classPrivateFieldGet(this, _element).classList.add('loading-new');
    }

    const parseData = data => {
      _classPrivateMethodGet(this, _parsePage, _parsePage2).call(this, data, nextUrl, resetContent);

      _classPrivateMethodGet(this, _triggerEvent, _triggerEvent2).call(this, 'infiniteScrollLoadedPage');

      _classPrivateMethodGet(this, _triggerEvent, _triggerEvent2).call(this, 'post-load'); // for scripts that depend on this event

    };

    fetch(nextUrl, {
      credentials: 'include'
    }).then(response => {
      // handle redirected URLs
      if (response.redirected) {
        nextUrl = response.url;
      }

      return response;
    }).then(response => response.text()).then(parseData).catch(error => {
      console.error(error);
      console.log('There has been an error loading the next page.', error.toString());
    });
  } // load the next page


  loadNextPage(resetContent = false) {
    if (!_classPrivateFieldGet(this, _element).classList.contains('loading')) {
      const nextUrl = _classPrivateMethodGet(this, _getNextPageURL, _getNextPageURL2).call(this, document.documentElement);

      if (nextUrl) {
        if (_classPrivateMethodGet(this, _triggerEvent, _triggerEvent2).call(this, 'infiniteScrollLoadingPage', {
          nextUrl,
          resetContent
        })) {
          this.loadPage(nextUrl, resetContent);
        }
      }
    }
  }

} // register as a jQuery plugin, if jQuery is available

function _loadInlineOptions2(settings = {}) {
  const inlineOptions = 'options' in _classPrivateFieldGet(this, _element).dataset ? JSON.parse(_classPrivateFieldGet(this, _element).dataset.options) : [];
  settings = _objectSpread(_objectSpread({}, settings), inlineOptions);
  Object.keys(settings).forEach(key => {
    this[key] = settings[key];
  });
}

function _getNextPageURL2(content) {
  let nextPageURL = false;
  const pages = typeof this.paginationLinksSelector == 'string' ? content.querySelectorAll(this.paginationLinksSelector) : this.paginationLinksSelector;

  if (pages.length) {
    nextPageURL = [].reduce.call(pages, (url, page) => {
      if (!url) {
        if (page.href != _classPrivateFieldGet(this, _currentLocation) && page.getAttribute('href') != _classPrivateFieldGet(this, _currentLocation)) {
          url = page.href;
        }
      }

      return url;
    }, false);
  }

  return nextPageURL;
}

function _parsePage2(data, nextUrl = false, resetContent = false) {
  // add the new items
  const newHtml = document.createElement('html');
  newHtml.innerHTML = data;
  const newItems = newHtml.querySelectorAll(`${this.containerSelector} ${this.itemSelector}`);
  const fragment = document.createDocumentFragment();
  if (newItems.length) newItems.forEach(item => fragment.appendChild(item));

  if (resetContent) {
    _classPrivateFieldGet(this, _container).innerHTML = '';
  }

  _classPrivateFieldGet(this, _container).appendChild(fragment); // allow hooking into the new items


  _classPrivateMethodGet(this, _triggerEvent, _triggerEvent2).call(this, 'infiniteScrollNewItems', {
    newItems,
    resetContent
  }); // trigger foundation if there is foundation in the page


  if ('jQuery' in window && 'foundation' in window.jQuery.fn) {
    window.jQuery(newItems).foundation();
  } // replace the pagination


  if (_classPrivateFieldGet(this, _pagination)) {
    const paginationContent = newHtml.querySelector(this.paginationContainerSelector);

    if (paginationContent) {
      _classPrivateFieldGet(this, _pagination).innerHTML = paginationContent.innerHTML;

      _classPrivateMethodGet(this, _initLoadOnScroll, _initLoadOnScroll2).call(this);
    } else {
      _classPrivateFieldGet(this, _pagination).innerHTML = '';
    }
  } // replace the other sync selectors


  if (this.syncSelectors && this.syncSelectors.length) {
    this.syncSelectors.forEach(selector => {
      const newElement = newHtml.querySelector(selector),
            oldElement = _classPrivateFieldGet(this, _element).querySelector(selector);

      if (newElement && oldElement) {
        oldElement.innerHTML = newElement.innerHTML;
      }
    });
  }

  if (resetContent) {
    _classPrivateMethodGet(this, _triggerEvent, _triggerEvent2).call(this, 'infiniteScrollFullPageContent', {
      newHtml,
      newItems
    });
  } // remove the "loading" class


  _classPrivateFieldGet(this, _element).classList.remove('loading');

  _classPrivateFieldGet(this, _element).classList.remove('loading-new');

  if (!resetContent) {
    this.currentPageNumber++;

    if (this.numberOfPages && this.currentPageNumber > this.numberOfPages) {
      _classPrivateFieldGet(this, _pagination).remove();
    }
  } else {
    this.currentPageNumber = 1;

    _classPrivateMethodGet(this, _loadInlineOptions, _loadInlineOptions2).call(this);

    if (nextUrl && this.updateUrl) history.pushState(null, null, nextUrl);
  }
}

function _triggerEvent2(eventType, detail = {}, target = null) {
  const event = new CustomEvent(eventType, {
    bubbles: true,
    cancelable: true,
    detail: _objectSpread({
      infiniteScroll: this
    }, detail)
  });
  return !target ? _classPrivateFieldGet(this, _element).dispatchEvent(event) : target.dispatchEvent(event);
}

function _initLoadOnScroll2() {
  _classPrivateFieldSet(this, _pagination, document.querySelector(this.paginationContainerSelector)); // observe intersection


  if (this.loadOnScroll && _classPrivateFieldGet(this, _pagination)) {
    if (!_classPrivateFieldGet(this, _observer)) {
      _classPrivateFieldSet(this, _observer, new IntersectionObserver(() => this.loadNextPage(), {
        rootMargin: '200px'
      }));
    }

    _classPrivateFieldGet(this, _observer).observe(_classPrivateFieldGet(this, _pagination));
  }
}

if ('jQuery' in window) {
  (function ($) {
    $.fn.lazyInfiniteScroll = function (settings = {}) {
      this.each(function () {
        if (!this.LazyInfiniteScroll) {
          // don't initialize twice
          new LazyInfiniteScroll(this, settings);
        }
      });
      return this;
    };
  })(window.jQuery);
}