/**
 * LazyInfiniteScroll - Plugin for infinite scroll
 * requires IntersectionObserver (or polyfill)
 *
 * Author: Bogdan Barbu
 * Team: Codingheads (codingheads.com)
 */
export interface LazyInfiniteScrollOptions {
    containerSelector?: string;
    itemSelector?: string;
    paginationContainerSelector?: string | false;
    paginationLinksSelector?: string | false;
    loadButton?: string | HTMLElement | false;
    loadOnScroll?: boolean;
    numberOfPages?: number | false;
    currentPageNumber?: number | false;
    syncSelectors?: string[] | false;
    updateUrl?: boolean;
}
export default class LazyInfiniteScroll {
    #private;
    containerSelector: string;
    itemSelector: string;
    paginationContainerSelector: string;
    paginationLinksSelector: string;
    loadButton: string | HTMLElement | false;
    loadOnScroll: boolean;
    numberOfPages: number | false;
    currentPageNumber: number;
    syncSelectors: string[];
    updateUrl: boolean;
    constructor(element?: HTMLElement, { containerSelector, itemSelector, paginationContainerSelector, paginationLinksSelector, loadButton, loadOnScroll, numberOfPages, currentPageNumber, syncSelectors, updateUrl, }?: LazyInfiniteScrollOptions, init?: boolean);
    loadPage(nextUrl: string, resetContent?: boolean): void;
    loadNextPage(resetContent?: boolean): void;
    init: () => void;
}
